#version 430 core

in vec2 TexCoords;

out vec4 color;

uniform vec3 textColor; //color uniform for adjusting the text's final color
uniform sampler2D textTexture; // mono-colored bitmap image of the glyph

void main() {	
        //first sample the color value of the bitmap texture
        //Because the texture's data is stored in just its red component,         
        //sample the r component of the texture as the sampled alpha value
        // By varying the color's alpha value the resulting color will be         
        //transparent for all the glyph's background colors and non-transparent         
        //for the actual character pixels. 
	vec4 sampled = vec4(1.0f,1.0f,1.0f, texture(textTexture,TexCoords).r);
        
        //multiply the RGB colors by textColor uniform to vary the text color.
        color = vec4(textColor,1.0)* sampled;
}

