#version 430 core

// the particles from the vertexShader
layout (points) in;						
// quads created
layout (triangle_strip, max_vertices = 4) out;	
	
uniform mat4 projMatrix;
uniform float distanceAtlas;					

in vData {
	float TTL1;
        vec4 texOffset;
        float blend;
} vertex[];

out vec2 texCoords;
out vec2 texCoords2;
out float blend;

// flat = no interpolation between vertices
flat out float TTL0;	


void main (void) {

        blend = vertex[0].blend;

        // size of quad
	const vec2 particleSize = vec2(0.98,0.98);			
        // particle position in view-space
	vec4 pos = gl_in[0].gl_Position;						

	// bottom-left corner
	vec2 va = pos.xy + vec2(-0.5, -0.5) * particleSize;
	gl_Position = projMatrix * vec4(va, pos.zw);	
	
        texCoords = vec2(0.0, 0.0);
        texCoords =  vec2(vertex[0].texOffset.x + distanceAtlas, vertex[0].texOffset.y);
        texCoords =  vec2(vertex[0].texOffset.x, vertex[0].texOffset.y + distanceAtlas);	
        //texCoords.y  = 1.0 - texCoords.y;

        texCoords2 = vec2(vertex[0].texOffset.z, vertex[0].texOffset.w + distanceAtlas);	
        //texCoords2.y = 1.0 - texCoords2.y;	
			
	TTL0 = vertex[0].TTL1;	
        //functions to generate primitives
        //each time EmitVertex is called, a vertex is added to the current primitive
        // When all vertices have been added EndPrimitive is called to generate the primitive.			
	EmitVertex();		
		
        //right-bottom
	vec2 vb = pos.xy + vec2(0.5, -0.5) * particleSize;
	gl_Position = projMatrix * vec4(vb, pos.zw);
	
        texCoords = vec2(1.0, 0.0);
        texCoords =  vec2(vertex[0].texOffset.x + distanceAtlas, vertex[0].texOffset.y + distanceAtlas);
        //texCoords.y  = 1.0 - texCoords.y;

        texCoords2 = vec2(vertex[0].texOffset.z + distanceAtlas, vertex[0].texOffset.w + distanceAtlas);	
        //texCoords2.y = 1.0 - texCoords2.y;      
	
	TTL0 = vertex[0].TTL1;
	EmitVertex();

        //left-top
	vec2 vc = pos.xy + vec2(-0.5, 0.5) * particleSize;
	gl_Position = projMatrix * vec4(vc, pos.zw);
	
        texCoords = vec2(0.0, 1.0);
        texCoords =  vec2(vertex[0].texOffset.x, vertex[0].texOffset.y);
        //texCoords.y  = 1.0 - texCoords.y;	


        texCoords2 = vec2(vertex[0].texOffset.z, vertex[0].texOffset.w);	
        //texCoords2.y = 1.0 - texCoords2.y;        

	TTL0 = vertex[0].TTL1;
	EmitVertex(); 
        
        //right-top
	vec2 vd = pos.xy + vec2(0.5, 0.5) * particleSize;
	gl_Position = projMatrix * vec4(vd, pos.zw);
	
        texCoords = vec2(1.0, 1.0);
        texCoords  = vec2(vertex[0].texOffset.x, vertex[0].texOffset.y + distanceAtlas);
        texCoords  = vec2(vertex[0].texOffset.x + distanceAtlas, vertex[0].texOffset.y);	
        //texCoords.y =  1.0 - texCoords.y;

        texCoords2 = vec2(vertex[0].texOffset.z + distanceAtlas, vertex[0].texOffset.w);	
        //texCoords2.y = 1.0 - texCoords2.y;
             

	TTL0 = vertex[0].TTL1;
	EmitVertex(); 	
        

	EndPrimitive();		
}