#version 430 core

// positions from compute shader
layout(location = 0) in vec4 position;

out vData{
   float TTL1;
   vec4 texOffset;
   float blend;
} vertex;

uniform mat4 modelViewMatrix;
uniform int nrOfRows;
uniform int lifespan;

vec2 setTextureOffset(int index){
         
         int column = int(mod(index,nrOfRows));
         int row = int(index/nrOfRows);


         float offsetX = float(column)/float(nrOfRows);
         float offsetY = float(row)/float(nrOfRows);

         vec2 result = vec2(offsetX,offsetY);
         return result;
}

void main() {

        vec4 vert = vec4(position.xyz,1.0f);
	gl_Position = modelViewMatrix * vert;
        vertex.TTL1 = position.w;

        //float lifeFactor = (((position.w - 0.0)*(1.0-0.0))/(ttl-0))+0;
        float lifeFactor = (((position.w - 0.0)*(1.0-0.0))/(lifespan-0))+0;

        int stageCount = nrOfRows * nrOfRows;

        float atlasProgression = lifeFactor * stageCount;

        int currentStage = int(atlasProgression);        
        int nextStage = stageCount - 1;

        if(currentStage != nextStage) nextStage = currentStage + 1;
        float blendFactor = mod(atlasProgression,1); 

        vec2 texOffset1 = setTextureOffset(currentStage);
        vec2 texOffset2 = setTextureOffset(nextStage);
        
        vertex.texOffset = vec4(texOffset1,texOffset2);
        
        vertex.blend = blendFactor;
}