#version 430 core
/*
* Copyright 2018 Vienna University of Technology.
* Institute of Computer Graphics and Algorithms.
* This file is part of the ECG Lab Framework and must not be redistributed.
*/

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

out VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
        
        vec4 FragPosLightSpace; //shadowMap
} vert;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform mat3 normalMatrix;

//shadow
uniform mat4 lightSpaceMatrix;

void main() {

        vec4 position_world_ = modelMatrix * vec4(position, 1.0);
	vert.position_world = position_world_.xyz;
        vert.FragPosLightSpace = lightSpaceMatrix * vec4(vert.position_world,1.0);  //shadowMap
	vert.normal_world = normalMatrix * normal;
	vert.uv = uv;
	
	gl_Position = viewProjMatrix * position_world_;
}